%------------------------------------------------------------------------------
% File     : SLP052^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer ListSlice problem prob_107__5616282_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : ListSlice/prob_107__5616282_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  185 (   0 unit;  12 type;   0 defn)
%            Number of atoms       : 1736 ( 178 equality; 879 variable)
%            Maximal formula depth :   13 (   8 average)
%            Number of connectives : 1256 (  49   ~;  14   |;  15   &;1012   @)
%                                         (   0 <=>; 166  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   17 (  17   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   14 (  12   :;   0   =)
%            Number of variables   :  396 (   0 sgn; 378   !;   4   ?;  14   ^)
%                                         ( 396   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:30:38.792
%------------------------------------------------------------------------------
% Could-be-implicit typings (2)
thf(ty_n_t__List__Olist_Itf__a_J,type,(
    list_a: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (10)
thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_Itf__a_J,type,(
    size_size_list_a: list_a > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Rings_Odivide__class_Odivide_001t__Nat__Onat,type,(
    divide_divide_nat: nat > nat > nat )).

thf(sy_v_i,type,(
    i: nat )).

thf(sy_v_k,type,(
    k: nat )).

thf(sy_v_xs,type,(
    xs: list_a )).

% Relevant facts (170)
thf(fact_0_div__mult__self__is__m,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( divide_divide_nat @ ( times_times_nat @ M @ N ) @ N )
        = M ) ) )).

% div_mult_self_is_m
thf(fact_1_div__mult__self1__is__m,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( divide_divide_nat @ ( times_times_nat @ N @ M ) @ N )
        = M ) ) )).

% div_mult_self1_is_m
thf(fact_2_mult__le__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% mult_le_cancel2
thf(fact_3_nat__mult__le__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_mult_le_cancel_disj
thf(fact_4_nat__mult__div__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( K = zero_zero_nat )
       => ( ( divide_divide_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
          = zero_zero_nat ) )
      & ( ( K != zero_zero_nat )
       => ( ( divide_divide_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
          = ( divide_divide_nat @ M @ N ) ) ) ) )).

% nat_mult_div_cancel_disj
thf(fact_5_div__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( divide_divide_nat @ M @ N )
        = zero_zero_nat ) ) )).

% div_less
thf(fact_6_mult__less__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% mult_less_cancel2
thf(fact_7_nat__0__less__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ M @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ M )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% nat_0_less_mult_iff
thf(fact_8_nat__mult__less__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% nat_mult_less_cancel_disj
thf(fact_9_diff__is__0__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% diff_is_0_eq
thf(fact_10_diff__is__0__eq_H,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat ) ) )).

% diff_is_0_eq'
thf(fact_11_zero__less__diff,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( minus_minus_nat @ N @ M ) )
      = ( ord_less_nat @ M @ N ) ) )).

% zero_less_diff
thf(fact_12_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_13_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_14_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_15_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_16_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_17_diff__self__eq__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ M )
      = zero_zero_nat ) )).

% diff_self_eq_0
thf(fact_18_diff__0__eq__0,axiom,(
    ! [N: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% diff_0_eq_0
thf(fact_19_diff__diff__cancel,axiom,(
    ! [I: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ N )
     => ( ( minus_minus_nat @ N @ ( minus_minus_nat @ N @ I ) )
        = I ) ) )).

% diff_diff_cancel
thf(fact_20_mult__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times_nat @ M @ K )
        = ( times_times_nat @ N @ K ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel2
thf(fact_21_mult__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel1
thf(fact_22_mult__0__right,axiom,(
    ! [M: nat] :
      ( ( times_times_nat @ M @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_0_right
thf(fact_23_mult__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        | ( N = zero_zero_nat ) ) ) )).

% mult_is_0
thf(fact_24_div__mult__mult1__if,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ( C = zero_zero_nat )
       => ( ( divide_divide_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) )
          = zero_zero_nat ) )
      & ( ( C != zero_zero_nat )
       => ( ( divide_divide_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) )
          = ( divide_divide_nat @ A @ B ) ) ) ) )).

% div_mult_mult1_if
thf(fact_25_div__mult__mult2,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( divide_divide_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) )
        = ( divide_divide_nat @ A @ B ) ) ) )).

% div_mult_mult2
thf(fact_26_div__mult__mult1,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( divide_divide_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) )
        = ( divide_divide_nat @ A @ B ) ) ) )).

% div_mult_mult1
thf(fact_27_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_28_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_29_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_30_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_31_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_32_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_33_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_34_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_35_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_36_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_37_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_38_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_39_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_40_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_41_size__neq__size__imp__neq,axiom,(
    ! [X: list_a,Y: list_a] :
      ( ( ( size_size_list_a @ X )
       != ( size_size_list_a @ Y ) )
     => ( X != Y ) ) )).

% size_neq_size_imp_neq
thf(fact_42_diff__commute,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I @ K ) @ J ) ) )).

% diff_commute
thf(fact_43_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_44_infinite__descent0,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N2 )
           => ( ~ ( P @ N2 )
             => ? [M2: nat] :
                  ( ( ord_less_nat @ M2 @ N2 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N ) ) ) )).

% infinite_descent0
thf(fact_45_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_46_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_47_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_48_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_49_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_50_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_51_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_52_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_53_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_54_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_55_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_56_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_57_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_nat @ M3 @ N3 )
          | ( M3 = N3 ) ) ) )).

% le_eq_less_or_eq
thf(fact_58_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_59_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_eq_nat @ M3 @ N3 )
          & ( M3 != N3 ) ) ) )).

% nat_less_le
thf(fact_60_minus__nat_Odiff__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ zero_zero_nat )
      = M ) )).

% minus_nat.diff_0
thf(fact_61_diffs0__imp__equal,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
     => ( ( ( minus_minus_nat @ N @ M )
          = zero_zero_nat )
       => ( M = N ) ) ) )).

% diffs0_imp_equal
thf(fact_62_less__imp__diff__less,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ J @ K )
     => ( ord_less_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% less_imp_diff_less
thf(fact_63_diff__less__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ord_less_nat @ M @ L )
       => ( ord_less_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) ) )).

% diff_less_mono2
thf(fact_64_diff__le__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) )).

% diff_le_mono2
thf(fact_65_le__diff__iff_H,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ C @ A ) @ ( minus_minus_nat @ C @ B ) )
          = ( ord_less_eq_nat @ B @ A ) ) ) ) )).

% le_diff_iff'
thf(fact_66_diff__le__self,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( minus_minus_nat @ M @ N ) @ M ) )).

% diff_le_self
thf(fact_67_diff__le__mono,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ M @ L ) @ ( minus_minus_nat @ N @ L ) ) ) )).

% diff_le_mono
thf(fact_68_Nat_Odiff__diff__eq,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( minus_minus_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( minus_minus_nat @ M @ N ) ) ) ) )).

% Nat.diff_diff_eq
thf(fact_69_le__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_eq_nat @ M @ N ) ) ) ) )).

% le_diff_iff
thf(fact_70_eq__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ( minus_minus_nat @ M @ K )
            = ( minus_minus_nat @ N @ K ) )
          = ( M = N ) ) ) ) )).

% eq_diff_iff
thf(fact_71_nat__mult__eq__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( K = zero_zero_nat )
        | ( M = N ) ) ) )).

% nat_mult_eq_cancel_disj
thf(fact_72_mult__0,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% mult_0
thf(fact_73_mult__le__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ K @ I ) @ ( times_times_nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_74_mult__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_75_mult__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_76_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ M ) ) )).

% le_square
thf(fact_77_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ ( times_times_nat @ M @ M ) ) ) )).

% le_cube
thf(fact_78_diff__mult__distrib2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times_nat @ K @ ( minus_minus_nat @ M @ N ) )
      = ( minus_minus_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) ) ) )).

% diff_mult_distrib2
thf(fact_79_diff__mult__distrib,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times_nat @ ( minus_minus_nat @ M @ N ) @ K )
      = ( minus_minus_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) ) ) )).

% diff_mult_distrib
thf(fact_80_div__le__dividend,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( divide_divide_nat @ M @ N ) @ M ) )).

% div_le_dividend
thf(fact_81_div__le__mono,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( divide_divide_nat @ M @ K ) @ ( divide_divide_nat @ N @ K ) ) ) )).

% div_le_mono
thf(fact_82_div__mult2__eq,axiom,(
    ! [M: nat,N: nat,Q: nat] :
      ( ( divide_divide_nat @ M @ ( times_times_nat @ N @ Q ) )
      = ( divide_divide_nat @ ( divide_divide_nat @ M @ N ) @ Q ) ) )).

% div_mult2_eq
thf(fact_83_ex__least__nat__le,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ zero_zero_nat )
       => ? [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K2 )
               => ~ ( P @ I3 ) )
            & ( P @ K2 ) ) ) ) )).

% ex_least_nat_le
thf(fact_84_diff__less,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_nat @ zero_zero_nat @ M )
       => ( ord_less_nat @ ( minus_minus_nat @ M @ N ) @ M ) ) ) )).

% diff_less
thf(fact_85_diff__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ A )
       => ( ord_less_nat @ ( minus_minus_nat @ A @ C ) @ ( minus_minus_nat @ B @ C ) ) ) ) )).

% diff_less_mono
thf(fact_86_less__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_nat @ M @ N ) ) ) ) )).

% less_diff_iff
thf(fact_87_nat__mult__less__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( ord_less_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
        = ( ord_less_nat @ M @ N ) ) ) )).

% nat_mult_less_cancel1
thf(fact_88_nat__mult__eq__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( ( times_times_nat @ K @ M )
          = ( times_times_nat @ K @ N ) )
        = ( M = N ) ) ) )).

% nat_mult_eq_cancel1
thf(fact_89_mult__less__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_nat @ ( times_times_nat @ K @ I ) @ ( times_times_nat @ K @ J ) ) ) ) )).

% mult_less_mono2
thf(fact_90_mult__less__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ K ) ) ) ) )).

% mult_less_mono1
thf(fact_91_Euclidean__Division_Odiv__eq__0__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( divide_divide_nat @ M @ N )
        = zero_zero_nat )
      = ( ( ord_less_nat @ M @ N )
        | ( N = zero_zero_nat ) ) ) )).

% Euclidean_Division.div_eq_0_iff
thf(fact_92_Euclidean__Division_Oless__mult__imp__div__less,axiom,(
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_less_nat @ M @ ( times_times_nat @ I @ N ) )
     => ( ord_less_nat @ ( divide_divide_nat @ M @ N ) @ I ) ) )).

% Euclidean_Division.less_mult_imp_div_less
thf(fact_93_times__div__less__eq__dividend,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ ( times_times_nat @ N @ ( divide_divide_nat @ M @ N ) ) @ M ) )).

% times_div_less_eq_dividend
thf(fact_94_div__times__less__eq__dividend,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( times_times_nat @ ( divide_divide_nat @ M @ N ) @ N ) @ M ) )).

% div_times_less_eq_dividend
thf(fact_95_nat__mult__le__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( ord_less_eq_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
        = ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_mult_le_cancel1
thf(fact_96_div__greater__zero__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( divide_divide_nat @ M @ N ) )
      = ( ( ord_less_eq_nat @ N @ M )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% div_greater_zero_iff
thf(fact_97_div__le__mono2,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ M )
     => ( ( ord_less_eq_nat @ M @ N )
       => ( ord_less_eq_nat @ ( divide_divide_nat @ K @ N ) @ ( divide_divide_nat @ K @ M ) ) ) ) )).

% div_le_mono2
thf(fact_98_nat__mult__div__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( divide_divide_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
        = ( divide_divide_nat @ M @ N ) ) ) )).

% nat_mult_div_cancel1
thf(fact_99_nonzero__mult__div__cancel__right,axiom,(
    ! [B: nat,A: nat] :
      ( ( B != zero_zero_nat )
     => ( ( divide_divide_nat @ ( times_times_nat @ A @ B ) @ B )
        = A ) ) )).

% nonzero_mult_div_cancel_right
thf(fact_100_nonzero__mult__div__cancel__left,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != zero_zero_nat )
     => ( ( divide_divide_nat @ ( times_times_nat @ A @ B ) @ A )
        = B ) ) )).

% nonzero_mult_div_cancel_left
thf(fact_101_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_102_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_103_mult__zero__left,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% mult_zero_left
thf(fact_104_mult__zero__right,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_zero_right
thf(fact_105_mult__eq__0__iff,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% mult_eq_0_iff
thf(fact_106_mult__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ( times_times_nat @ C @ A )
        = ( times_times_nat @ C @ B ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_107_mult__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ( times_times_nat @ A @ C )
        = ( times_times_nat @ B @ C ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_108_zero__diff,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% zero_diff
thf(fact_109_diff__zero,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ zero_zero_nat )
      = A ) )).

% diff_zero
thf(fact_110_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ A )
      = zero_zero_nat ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_111_div__0,axiom,(
    ! [A: nat] :
      ( ( divide_divide_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% div_0
thf(fact_112_div__by__0,axiom,(
    ! [A: nat] :
      ( ( divide_divide_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% div_by_0
thf(fact_113_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_114_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_115_mult_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_116_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A2: nat,B2: nat] :
          ( times_times_nat @ B2 @ A2 ) ) )).

% mult.commute
thf(fact_117_mult_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A @ C ) )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_118_diff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_119_eq__imp__diff__eq,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( M = N )
     => ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) ) ) )).

% eq_imp_diff_eq
thf(fact_120_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_121_ge__less__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,N3: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ X3 @ A2 )
         => ( N3 != X3 ) ) ) )).

% ge_less_neq_conv
thf(fact_122_less__ge__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [N3: nat,A2: nat] :
        ! [X3: nat] :
          ( ( ord_less_eq_nat @ A2 @ X3 )
         => ( N3 != X3 ) ) ) )).

% less_ge_neq_conv
thf(fact_123_greater__le__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,N3: nat] :
        ! [X3: nat] :
          ( ( ord_less_eq_nat @ X3 @ A2 )
         => ( N3 != X3 ) ) ) )).

% greater_le_neq_conv
thf(fact_124_le__greater__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [N3: nat,A2: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ A2 @ X3 )
         => ( N3 != X3 ) ) ) )).

% le_greater_neq_conv
thf(fact_125_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_126_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_127_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_128_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_129_mult__not__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
       != zero_zero_nat )
     => ( ( A != zero_zero_nat )
        & ( B != zero_zero_nat ) ) ) )).

% mult_not_zero
thf(fact_130_divisors__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
     => ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% divisors_zero
thf(fact_131_no__zero__divisors,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != zero_zero_nat )
     => ( ( B != zero_zero_nat )
       => ( ( times_times_nat @ A @ B )
         != zero_zero_nat ) ) ) )).

% no_zero_divisors
thf(fact_132_mult__left__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ C @ A )
          = ( times_times_nat @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_133_mult__right__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ A @ C )
          = ( times_times_nat @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_134_left__diff__distrib_H,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( times_times_nat @ ( minus_minus_nat @ B @ C ) @ A )
      = ( minus_minus_nat @ ( times_times_nat @ B @ A ) @ ( times_times_nat @ C @ A ) ) ) )).

% left_diff_distrib'
thf(fact_135_right__diff__distrib_H,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( minus_minus_nat @ B @ C ) )
      = ( minus_minus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% right_diff_distrib'
thf(fact_136_gr__implies__gr0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_implies_gr0
thf(fact_137_less__diff__imp__less,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_nat @ I @ J ) ) )).

% less_diff_imp_less
thf(fact_138_nat__diff__left__cancel__eq1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ M @ K )
       => ( M = N ) ) ) )).

% nat_diff_left_cancel_eq1
thf(fact_139_nat__diff__left__cancel__eq2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ N @ K )
       => ( M = N ) ) ) )).

% nat_diff_left_cancel_eq2
thf(fact_140_nat__diff__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ord_less_nat @ N @ M ) ) )).

% nat_diff_left_cancel_less
thf(fact_141_nat__diff__right__cancel__eq1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ M )
       => ( M = N ) ) ) )).

% nat_diff_right_cancel_eq1
thf(fact_142_nat__diff__right__cancel__eq2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ N )
       => ( M = N ) ) ) )).

% nat_diff_right_cancel_eq2
thf(fact_143_nat__diff__right__cancel__less,axiom,(
    ! [N: nat,K: nat,M: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ N @ K ) @ ( minus_minus_nat @ M @ K ) )
     => ( ord_less_nat @ N @ M ) ) )).

% nat_diff_right_cancel_less
thf(fact_144_le__diff__swap,axiom,(
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less_eq_nat @ I @ K )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ J ) @ I )
          = ( ord_less_eq_nat @ ( minus_minus_nat @ K @ I ) @ J ) ) ) ) )).

% le_diff_swap
thf(fact_145_le__diff__imp__le,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_eq_nat @ I @ J ) ) )).

% le_diff_imp_le
thf(fact_146_le__imp__diff__le,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ J @ K )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% le_imp_diff_le
thf(fact_147_eq__diff__left__iff,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ K )
     => ( ( ord_less_eq_nat @ N @ K )
       => ( ( ( minus_minus_nat @ K @ M )
            = ( minus_minus_nat @ K @ N ) )
          = ( M = N ) ) ) ) )).

% eq_diff_left_iff
thf(fact_148_le__diff__le__imp__le,axiom,(
    ! [I: nat,J: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ N ) ) ) ) )).

% le_diff_le_imp_le
thf(fact_149_nat__diff__left__cancel__le2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_eq_nat @ N @ K )
       => ( ord_less_eq_nat @ N @ M ) ) ) )).

% nat_diff_left_cancel_le2
thf(fact_150_nat__diff__right__cancel__le2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_diff_right_cancel_le2
thf(fact_151_mult__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_152_mult__mono_H,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_153_mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_154_mult__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_155_split__mult__neg__le,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( ( ord_less_eq_nat @ zero_zero_nat @ A )
          & ( ord_less_eq_nat @ B @ zero_zero_nat ) )
        | ( ( ord_less_eq_nat @ A @ zero_zero_nat )
          & ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )
     => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) )).

% split_mult_neg_le
thf(fact_156_mult__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_157_mult__nonneg__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos
thf(fact_158_mult__nonpos__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonpos_nonneg
thf(fact_159_mult__nonneg__nonpos2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_160_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_161_mult__neg__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ zero_zero_nat )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_neg_pos
thf(fact_162_mult__pos__neg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_pos_neg
thf(fact_163_mult__pos__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_pos_pos
thf(fact_164_mult__pos__neg2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_pos_neg2
thf(fact_165_zero__less__mult__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) )
     => ( ( ord_less_nat @ zero_zero_nat @ A )
       => ( ord_less_nat @ zero_zero_nat @ B ) ) ) )).

% zero_less_mult_pos
thf(fact_166_zero__less__mult__pos2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ B @ A ) )
     => ( ( ord_less_nat @ zero_zero_nat @ A )
       => ( ord_less_nat @ zero_zero_nat @ B ) ) ) )).

% zero_less_mult_pos2
thf(fact_167_mult__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_strict_left_mono
thf(fact_168_mult__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_strict_right_mono
thf(fact_169_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono

% Conjectures (3)
thf(conj_0,hypothesis,(
    ord_less_nat @ zero_zero_nat @ k )).

thf(conj_1,hypothesis,(
    ord_less_nat @ i @ ( divide_divide_nat @ ( size_size_list_a @ xs ) @ k ) )).

thf(conj_2,conjecture,(
    ord_less_eq_nat @ k @ ( minus_minus_nat @ ( times_times_nat @ ( divide_divide_nat @ ( size_size_list_a @ xs ) @ k ) @ k ) @ ( times_times_nat @ i @ k ) ) )).

%------------------------------------------------------------------------------
