%------------------------------------------------------------------------------
% File     : SLP054^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer ListSlice problem prob_74__5615592_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : ListSlice/prob_74__5615592_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  227 (   0 unit;  12 type;   0 defn)
%            Number of atoms       : 2361 ( 169 equality;1370 variable)
%            Maximal formula depth :   16 (   9 average)
%            Number of connectives : 1839 (  31   ~;   6   |;  15   &;1605   @)
%                                         (   0 <=>; 182  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   18 (  18   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   14 (  12   :;   0   =)
%            Number of variables   :  632 (   0 sgn; 597   !;   5   ?;  30   ^)
%                                         ( 632   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:30:12.263
%------------------------------------------------------------------------------
% Could-be-implicit typings (2)
thf(ty_n_t__List__Olist_Itf__a_J,type,(
    list_a: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (10)
thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_Itf__a_J,type,(
    size_size_list_a: list_a > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Omin_001t__Nat__Onat,type,(
    ord_min_nat: nat > nat > nat )).

thf(sy_v_k,type,(
    k: nat )).

thf(sy_v_m,type,(
    m: nat )).

thf(sy_v_xs,type,(
    xs: list_a )).

% Relevant facts (212)
thf(fact_0_Nat_Oadd__diff__assoc,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I @ J ) @ K ) ) ) )).

% Nat.add_diff_assoc
thf(fact_1_Nat_Oadd__diff__assoc2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ J @ K ) @ I )
        = ( minus_minus_nat @ ( plus_plus_nat @ J @ I ) @ K ) ) ) )).

% Nat.add_diff_assoc2
thf(fact_2_Util__Nat_Odiff__diff__right,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) ) )).

% Util_Nat.diff_diff_right
thf(fact_3_le__add__diff__inverse,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( plus_plus_nat @ B @ ( minus_minus_nat @ A @ B ) )
        = A ) ) )).

% le_add_diff_inverse
thf(fact_4_le__add__diff__inverse2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ A @ B ) @ B )
        = A ) ) )).

% le_add_diff_inverse2
thf(fact_5_min__less__iff__conj,axiom,(
    ! [Z: nat,X: nat,Y: nat] :
      ( ( ord_less_nat @ Z @ ( ord_min_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Z @ X )
        & ( ord_less_nat @ Z @ Y ) ) ) )).

% min_less_iff_conj
thf(fact_6_diff__diff__left,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ I @ ( plus_plus_nat @ J @ K ) ) ) )).

% diff_diff_left
thf(fact_7_min_Obounded__iff,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( ord_min_nat @ B @ C ) )
      = ( ( ord_less_eq_nat @ A @ B )
        & ( ord_less_eq_nat @ A @ C ) ) ) )).

% min.bounded_iff
thf(fact_8_nat__less__add__iff1,axiom,(
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ J @ I )
     => ( ( ord_less_nat @ ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ M ) @ ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ N ) )
        = ( ord_less_nat @ ( plus_plus_nat @ ( times_times_nat @ ( minus_minus_nat @ I @ J ) @ U ) @ M ) @ N ) ) ) )).

% nat_less_add_iff1
thf(fact_9_nat__less__add__iff2,axiom,(
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_nat @ ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ M ) @ ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ N ) )
        = ( ord_less_nat @ M @ ( plus_plus_nat @ ( times_times_nat @ ( minus_minus_nat @ J @ I ) @ U ) @ N ) ) ) ) )).

% nat_less_add_iff2
thf(fact_10_diff__diff__cancel,axiom,(
    ! [I: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ N )
     => ( ( minus_minus_nat @ N @ ( minus_minus_nat @ N @ I ) )
        = I ) ) )).

% diff_diff_cancel
thf(fact_11_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_12_min_Oright__idem,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_min_nat @ ( ord_min_nat @ A @ B ) @ B )
      = ( ord_min_nat @ A @ B ) ) )).

% min.right_idem
thf(fact_13_min_Oleft__idem,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_min_nat @ A @ ( ord_min_nat @ A @ B ) )
      = ( ord_min_nat @ A @ B ) ) )).

% min.left_idem
thf(fact_14_min_Oidem,axiom,(
    ! [A: nat] :
      ( ( ord_min_nat @ A @ A )
      = A ) )).

% min.idem
thf(fact_15_nat__add__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% nat_add_left_cancel_less
thf(fact_16_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_17_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_18_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_19_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_20_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_21_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_22_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_23_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_24_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_25_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_26_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_27_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_28_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_29_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_30_size__neq__size__imp__neq,axiom,(
    ! [X: list_a,Y: list_a] :
      ( ( ( size_size_list_a @ X )
       != ( size_size_list_a @ Y ) )
     => ( X != Y ) ) )).

% size_neq_size_imp_neq
thf(fact_31_eq__imp__diff__eq,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( M = N )
     => ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) ) ) )).

% eq_imp_diff_eq
thf(fact_32_diff__commute,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I @ K ) @ J ) ) )).

% diff_commute
thf(fact_33_min_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_min_nat @ B @ ( ord_min_nat @ A @ C ) )
      = ( ord_min_nat @ A @ ( ord_min_nat @ B @ C ) ) ) )).

% min.left_commute
thf(fact_34_min_Ocommute,axiom,
    ( ord_min_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ord_min_nat @ B2 @ A2 ) ) )).

% min.commute
thf(fact_35_min_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_min_nat @ ( ord_min_nat @ A @ B ) @ C )
      = ( ord_min_nat @ A @ ( ord_min_nat @ B @ C ) ) ) )).

% min.assoc
thf(fact_36_le__greater__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [N3: nat,A2: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ A2 @ X3 )
         => ( N3 != X3 ) ) ) )).

% le_greater_neq_conv
thf(fact_37_greater__le__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,N3: nat] :
        ! [X3: nat] :
          ( ( ord_less_eq_nat @ X3 @ A2 )
         => ( N3 != X3 ) ) ) )).

% greater_le_neq_conv
thf(fact_38_less__ge__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [N3: nat,A2: nat] :
        ! [X3: nat] :
          ( ( ord_less_eq_nat @ A2 @ X3 )
         => ( N3 != X3 ) ) ) )).

% less_ge_neq_conv
thf(fact_39_ge__less__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,N3: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ X3 @ A2 )
         => ( N3 != X3 ) ) ) )).

% ge_less_neq_conv
thf(fact_40_combine__common__factor,axiom,(
    ! [A: nat,E: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( times_times_nat @ A @ E ) @ ( plus_plus_nat @ ( times_times_nat @ B @ E ) @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_41_distrib__right,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% distrib_right
thf(fact_42_distrib__left,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( plus_plus_nat @ B @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% distrib_left
thf(fact_43_comm__semiring__class_Odistrib,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_44_right__diff__distrib_H,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( minus_minus_nat @ B @ C ) )
      = ( minus_minus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% right_diff_distrib'
thf(fact_45_left__diff__distrib_H,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( times_times_nat @ ( minus_minus_nat @ B @ C ) @ A )
      = ( minus_minus_nat @ ( times_times_nat @ B @ A ) @ ( times_times_nat @ C @ A ) ) ) )).

% left_diff_distrib'
thf(fact_46_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_47_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_48_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_49_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_nat @ M3 @ N3 )
          | ( M3 = N3 ) ) ) )).

% le_eq_less_or_eq
thf(fact_50_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_51_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_eq_nat @ M3 @ N3 )
          & ( M3 != N3 ) ) ) )).

% nat_less_le
thf(fact_52_add__less__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ ( plus_plus_nat @ K @ I ) @ ( plus_plus_nat @ K @ J ) ) ) )).

% add_less_mono2
thf(fact_53_less__add__eq__less,axiom,(
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ K @ L )
     => ( ( ( plus_plus_nat @ M @ L )
          = ( plus_plus_nat @ K @ N ) )
       => ( ord_less_nat @ M @ N ) ) ) )).

% less_add_eq_less
thf(fact_54_add__lessD2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ K )
     => ( ord_less_nat @ J @ K ) ) )).

% add_lessD2
thf(fact_55_trans__less__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_less_add2
thf(fact_56_trans__less__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_less_add1
thf(fact_57_add__less__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_less_mono1
thf(fact_58_not__add__less2,axiom,(
    ! [J: nat,I: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ J @ I ) @ I ) )).

% not_add_less2
thf(fact_59_not__add__less1,axiom,(
    ! [I: nat,J: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ I ) )).

% not_add_less1
thf(fact_60_add__less__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ K @ L )
       => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_less_mono
thf(fact_61_add__lessD1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ K )
     => ( ord_less_nat @ I @ K ) ) )).

% add_lessD1
thf(fact_62_nat__diff__right__cancel__less,axiom,(
    ! [N: nat,K: nat,M: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ N @ K ) @ ( minus_minus_nat @ M @ K ) )
     => ( ord_less_nat @ N @ M ) ) )).

% nat_diff_right_cancel_less
thf(fact_63_nat__diff__right__cancel__eq2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ N )
       => ( M = N ) ) ) )).

% nat_diff_right_cancel_eq2
thf(fact_64_nat__diff__right__cancel__eq1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ M )
       => ( M = N ) ) ) )).

% nat_diff_right_cancel_eq1
thf(fact_65_nat__diff__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ord_less_nat @ N @ M ) ) )).

% nat_diff_left_cancel_less
thf(fact_66_nat__diff__left__cancel__eq2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ N @ K )
       => ( M = N ) ) ) )).

% nat_diff_left_cancel_eq2
thf(fact_67_nat__diff__left__cancel__eq1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ M @ K )
       => ( M = N ) ) ) )).

% nat_diff_left_cancel_eq1
thf(fact_68_less__diff__imp__less,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_nat @ I @ J ) ) )).

% less_diff_imp_less
thf(fact_69_less__imp__diff__less,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ J @ K )
     => ( ord_less_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% less_imp_diff_less
thf(fact_70_diff__less__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ord_less_nat @ M @ L )
       => ( ord_less_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) ) )).

% diff_less_mono2
thf(fact_71_add__le__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ K @ I ) @ ( plus_plus_nat @ K @ J ) ) ) )).

% add_le_mono2
thf(fact_72_nat__le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
        ? [K2: nat] :
          ( N3
          = ( plus_plus_nat @ M3 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_73_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_74_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_75_add__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_76_add__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_77_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq_nat @ K @ L )
     => ? [N2: nat] :
          ( L
          = ( plus_plus_nat @ K @ N2 ) ) ) )).

% le_Suc_ex
thf(fact_78_add__leD2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ K @ N ) ) )).

% add_leD2
thf(fact_79_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% add_leD1
thf(fact_80_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ M @ N ) ) )).

% le_add2
thf(fact_81_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ N @ M ) ) )).

% le_add1
thf(fact_82_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq_nat @ M @ N )
         => ~ ( ord_less_eq_nat @ K @ N ) ) ) )).

% add_leE
thf(fact_83_nat__diff__right__cancel__le2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_diff_right_cancel_le2
thf(fact_84_nat__diff__left__cancel__le2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_eq_nat @ N @ K )
       => ( ord_less_eq_nat @ N @ M ) ) ) )).

% nat_diff_left_cancel_le2
thf(fact_85_le__diff__le__imp__le,axiom,(
    ! [I: nat,J: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ N ) ) ) ) )).

% le_diff_le_imp_le
thf(fact_86_eq__diff__left__iff,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ K )
     => ( ( ord_less_eq_nat @ N @ K )
       => ( ( ( minus_minus_nat @ K @ M )
            = ( minus_minus_nat @ K @ N ) )
          = ( M = N ) ) ) ) )).

% eq_diff_left_iff
thf(fact_87_le__imp__diff__le,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ J @ K )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% le_imp_diff_le
thf(fact_88_le__diff__imp__le,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_eq_nat @ I @ J ) ) )).

% le_diff_imp_le
thf(fact_89_le__diff__swap,axiom,(
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less_eq_nat @ I @ K )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ J ) @ I )
          = ( ord_less_eq_nat @ ( minus_minus_nat @ K @ I ) @ J ) ) ) ) )).

% le_diff_swap
thf(fact_90_diff__le__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) )).

% diff_le_mono2
thf(fact_91_le__diff__iff_H,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ C @ A ) @ ( minus_minus_nat @ C @ B ) )
          = ( ord_less_eq_nat @ B @ A ) ) ) ) )).

% le_diff_iff'
thf(fact_92_diff__le__self,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( minus_minus_nat @ M @ N ) @ M ) )).

% diff_le_self
thf(fact_93_diff__le__mono,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ M @ L ) @ ( minus_minus_nat @ N @ L ) ) ) )).

% diff_le_mono
thf(fact_94_Nat_Odiff__diff__eq,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( minus_minus_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( minus_minus_nat @ M @ N ) ) ) ) )).

% Nat.diff_diff_eq
thf(fact_95_le__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_eq_nat @ M @ N ) ) ) ) )).

% le_diff_iff
thf(fact_96_eq__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ( minus_minus_nat @ M @ K )
            = ( minus_minus_nat @ N @ K ) )
          = ( M = N ) ) ) ) )).

% eq_diff_iff
thf(fact_97_min__le__iff__disj,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ ( ord_min_nat @ X @ Y ) @ Z )
      = ( ( ord_less_eq_nat @ X @ Z )
        | ( ord_less_eq_nat @ Y @ Z ) ) ) )).

% min_le_iff_disj
thf(fact_98_min_OcoboundedI2,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ C )
     => ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ C ) ) )).

% min.coboundedI2
thf(fact_99_min_OcoboundedI1,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ C ) ) )).

% min.coboundedI1
thf(fact_100_min_Oabsorb__iff2,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_min_nat @ A2 @ B2 )
          = B2 ) ) )).

% min.absorb_iff2
thf(fact_101_min_Oabsorb__iff1,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_min_nat @ A2 @ B2 )
          = A2 ) ) )).

% min.absorb_iff1
thf(fact_102_min_Ocobounded2,axiom,(
    ! [A: nat,B: nat] :
      ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ B ) )).

% min.cobounded2
thf(fact_103_min_Ocobounded1,axiom,(
    ! [A: nat,B: nat] :
      ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ A ) )).

% min.cobounded1
thf(fact_104_min_Oorder__iff,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( A2
          = ( ord_min_nat @ A2 @ B2 ) ) ) )).

% min.order_iff
thf(fact_105_min_OboundedI,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ A @ C )
       => ( ord_less_eq_nat @ A @ ( ord_min_nat @ B @ C ) ) ) ) )).

% min.boundedI
thf(fact_106_min_OboundedE,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( ord_min_nat @ B @ C ) )
     => ~ ( ( ord_less_eq_nat @ A @ B )
         => ~ ( ord_less_eq_nat @ A @ C ) ) ) )).

% min.boundedE
thf(fact_107_min_Oabsorb2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_min_nat @ A @ B )
        = B ) ) )).

% min.absorb2
thf(fact_108_min_Oabsorb1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_min_nat @ A @ B )
        = A ) ) )).

% min.absorb1
thf(fact_109_min_OorderI,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( ord_min_nat @ A @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% min.orderI
thf(fact_110_min_OorderE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( A
        = ( ord_min_nat @ A @ B ) ) ) )).

% min.orderE
thf(fact_111_min_Omono,axiom,(
    ! [A: nat,C: nat,B: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ D )
       => ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ ( ord_min_nat @ C @ D ) ) ) ) )).

% min.mono
thf(fact_112_diff__add__inverse2,axiom,(
    ! [M: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ M @ N ) @ N )
      = M ) )).

% diff_add_inverse2
thf(fact_113_diff__add__inverse,axiom,(
    ! [N: nat,M: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ N @ M ) @ N )
      = M ) )).

% diff_add_inverse
thf(fact_114_diff__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ M @ K ) @ ( plus_plus_nat @ N @ K ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% diff_cancel2
thf(fact_115_Nat_Odiff__cancel,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% Nat.diff_cancel
thf(fact_116_min_Ostrict__coboundedI2,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( ord_less_nat @ B @ C )
     => ( ord_less_nat @ ( ord_min_nat @ A @ B ) @ C ) ) )).

% min.strict_coboundedI2
thf(fact_117_min_Ostrict__coboundedI1,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ A @ C )
     => ( ord_less_nat @ ( ord_min_nat @ A @ B ) @ C ) ) )).

% min.strict_coboundedI1
thf(fact_118_min_Ostrict__order__iff,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( A2
            = ( ord_min_nat @ A2 @ B2 ) )
          & ( A2 != B2 ) ) ) )).

% min.strict_order_iff
thf(fact_119_min_Ostrict__boundedE,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( ord_min_nat @ B @ C ) )
     => ~ ( ( ord_less_nat @ A @ B )
         => ~ ( ord_less_nat @ A @ C ) ) ) )).

% min.strict_boundedE
thf(fact_120_min__less__iff__disj,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ ( ord_min_nat @ X @ Y ) @ Z )
      = ( ( ord_less_nat @ X @ Z )
        | ( ord_less_nat @ Y @ Z ) ) ) )).

% min_less_iff_disj
thf(fact_121_mult__le__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ K @ I ) @ ( times_times_nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_122_mult__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_123_mult__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_124_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ M ) ) )).

% le_square
thf(fact_125_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ ( times_times_nat @ M @ M ) ) ) )).

% le_cube
thf(fact_126_left__add__mult__distrib,axiom,(
    ! [I: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ K ) )
      = ( plus_plus_nat @ ( times_times_nat @ ( plus_plus_nat @ I @ J ) @ U ) @ K ) ) )).

% left_add_mult_distrib
thf(fact_127_add__mult__distrib2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times_nat @ K @ ( plus_plus_nat @ M @ N ) )
      = ( plus_plus_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) ) ) )).

% add_mult_distrib2
thf(fact_128_add__mult__distrib,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ M @ N ) @ K )
      = ( plus_plus_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) ) ) )).

% add_mult_distrib
thf(fact_129_diff__mult__distrib2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times_nat @ K @ ( minus_minus_nat @ M @ N ) )
      = ( minus_minus_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) ) ) )).

% diff_mult_distrib2
thf(fact_130_diff__mult__distrib,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times_nat @ ( minus_minus_nat @ M @ N ) @ K )
      = ( minus_minus_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) ) ) )).

% diff_mult_distrib
thf(fact_131_min__diff,axiom,(
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_min_nat @ ( minus_minus_nat @ M @ I ) @ ( minus_minus_nat @ N @ I ) )
      = ( minus_minus_nat @ ( ord_min_nat @ M @ N ) @ I ) ) )).

% min_diff
thf(fact_132_nat__mult__min__right,axiom,(
    ! [M: nat,N: nat,Q: nat] :
      ( ( times_times_nat @ M @ ( ord_min_nat @ N @ Q ) )
      = ( ord_min_nat @ ( times_times_nat @ M @ N ) @ ( times_times_nat @ M @ Q ) ) ) )).

% nat_mult_min_right
thf(fact_133_nat__mult__min__left,axiom,(
    ! [M: nat,N: nat,Q: nat] :
      ( ( times_times_nat @ ( ord_min_nat @ M @ N ) @ Q )
      = ( ord_min_nat @ ( times_times_nat @ M @ Q ) @ ( times_times_nat @ N @ Q ) ) ) )).

% nat_mult_min_left
thf(fact_134_add__le__add__imp__diff__le,axiom,(
    ! [I: nat,K: nat,N: nat,J: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ N )
     => ( ( ord_less_eq_nat @ N @ ( plus_plus_nat @ J @ K ) )
       => ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ N )
         => ( ( ord_less_eq_nat @ N @ ( plus_plus_nat @ J @ K ) )
           => ( ord_less_eq_nat @ ( minus_minus_nat @ N @ K ) @ J ) ) ) ) ) )).

% add_le_add_imp_diff_le
thf(fact_135_add__le__imp__le__diff,axiom,(
    ! [I: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ N )
     => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ N @ K ) ) ) )).

% add_le_imp_le_diff
thf(fact_136_linordered__semidom__class_Oadd__diff__inverse,axiom,(
    ! [A: nat,B: nat] :
      ( ~ ( ord_less_nat @ A @ B )
     => ( ( plus_plus_nat @ B @ ( minus_minus_nat @ A @ B ) )
        = A ) ) )).

% linordered_semidom_class.add_diff_inverse
thf(fact_137_mono__nat__linear__lb,axiom,(
    ! [F: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N2: nat] :
          ( ( ord_less_nat @ M4 @ N2 )
         => ( ord_less_nat @ ( F @ M4 ) @ ( F @ N2 ) ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ ( F @ M ) @ K ) @ ( F @ ( plus_plus_nat @ M @ K ) ) ) ) )).

% mono_nat_linear_lb
thf(fact_138_nat__diff__right__cancel__le1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ M )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_diff_right_cancel_le1
thf(fact_139_nat__diff__left__cancel__le1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ M @ K )
       => ( ord_less_eq_nat @ N @ M ) ) ) )).

% nat_diff_left_cancel_le1
thf(fact_140_less__diff__le__imp__less,axiom,(
    ! [I: nat,J: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( ord_less_nat @ I @ ( minus_minus_nat @ J @ N ) ) ) ) )).

% less_diff_le_imp_less
thf(fact_141_diff__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ A )
       => ( ord_less_nat @ ( minus_minus_nat @ A @ C ) @ ( minus_minus_nat @ B @ C ) ) ) ) )).

% diff_less_mono
thf(fact_142_less__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_nat @ M @ N ) ) ) ) )).

% less_diff_iff
thf(fact_143_diff__less__imp__less__add,axiom,(
    ! [J: nat,K: nat,I: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ J @ K ) @ I )
     => ( ord_less_nat @ J @ ( plus_plus_nat @ I @ K ) ) ) )).

% diff_less_imp_less_add
thf(fact_144_add__diff__inverse__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ~ ( ord_less_nat @ M @ N )
     => ( ( plus_plus_nat @ N @ ( minus_minus_nat @ M @ N ) )
        = M ) ) )).

% add_diff_inverse_nat
thf(fact_145_less__add__diff,axiom,(
    ! [K: nat,N: nat,M: nat] :
      ( ( ord_less_nat @ K @ N )
     => ( ord_less_nat @ M @ ( minus_minus_nat @ ( plus_plus_nat @ N @ M ) @ K ) ) ) )).

% less_add_diff
thf(fact_146_less__diff__conv,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ ( minus_minus_nat @ J @ K ) )
      = ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) )).

% less_diff_conv
thf(fact_147_add__le__imp__le__diff2,axiom,(
    ! [K: nat,I: nat,J: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ I ) @ J )
     => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ K ) ) ) )).

% add_le_imp_le_diff2
thf(fact_148_add__le__imp__le__diff1,axiom,(
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ J )
     => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ K ) ) ) )).

% add_le_imp_le_diff1
thf(fact_149_Nat_Ole__imp__diff__is__add,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ( minus_minus_nat @ J @ I )
          = K )
        = ( J
          = ( plus_plus_nat @ K @ I ) ) ) ) )).

% Nat.le_imp_diff_is_add
thf(fact_150_add__diff__le,axiom,(
    ! [K: nat,N: nat,M: nat] :
      ( ( ord_less_eq_nat @ K @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ ( plus_plus_nat @ M @ K ) @ N ) @ M ) ) )).

% add_diff_le
thf(fact_151_Nat_Odiff__add__assoc2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ J @ I ) @ K )
        = ( plus_plus_nat @ ( minus_minus_nat @ J @ K ) @ I ) ) ) )).

% Nat.diff_add_assoc2
thf(fact_152_Nat_Odiff__add__assoc,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ I @ J ) @ K )
        = ( plus_plus_nat @ I @ ( minus_minus_nat @ J @ K ) ) ) ) )).

% Nat.diff_add_assoc
thf(fact_153_Nat_Ole__diff__conv2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) ) )).

% Nat.le_diff_conv2
thf(fact_154_le__diff__conv,axiom,(
    ! [J: nat,K: nat,I: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ J @ K ) @ I )
      = ( ord_less_eq_nat @ J @ ( plus_plus_nat @ I @ K ) ) ) )).

% le_diff_conv
thf(fact_155_less__diff__conv2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( ord_less_nat @ ( minus_minus_nat @ J @ K ) @ I )
        = ( ord_less_nat @ J @ ( plus_plus_nat @ I @ K ) ) ) ) )).

% less_diff_conv2
thf(fact_156_nat__diff__add__eq2,axiom,(
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ M ) @ ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ N ) )
        = ( minus_minus_nat @ M @ ( plus_plus_nat @ ( times_times_nat @ ( minus_minus_nat @ J @ I ) @ U ) @ N ) ) ) ) )).

% nat_diff_add_eq2
thf(fact_157_nat__diff__add__eq1,axiom,(
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ J @ I )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ M ) @ ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ N ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ ( times_times_nat @ ( minus_minus_nat @ I @ J ) @ U ) @ M ) @ N ) ) ) )).

% nat_diff_add_eq1
thf(fact_158_nat__le__add__iff2,axiom,(
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ M ) @ ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ N ) )
        = ( ord_less_eq_nat @ M @ ( plus_plus_nat @ ( times_times_nat @ ( minus_minus_nat @ J @ I ) @ U ) @ N ) ) ) ) )).

% nat_le_add_iff2
thf(fact_159_nat__le__add__iff1,axiom,(
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ J @ I )
     => ( ( ord_less_eq_nat @ ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ M ) @ ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ N ) )
        = ( ord_less_eq_nat @ ( plus_plus_nat @ ( times_times_nat @ ( minus_minus_nat @ I @ J ) @ U ) @ M ) @ N ) ) ) )).

% nat_le_add_iff1
thf(fact_160_nat__eq__add__iff2,axiom,(
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ M )
          = ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ N ) )
        = ( M
          = ( plus_plus_nat @ ( times_times_nat @ ( minus_minus_nat @ J @ I ) @ U ) @ N ) ) ) ) )).

% nat_eq_add_iff2
thf(fact_161_nat__eq__add__iff1,axiom,(
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ J @ I )
     => ( ( ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ M )
          = ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ N ) )
        = ( ( plus_plus_nat @ ( times_times_nat @ ( minus_minus_nat @ I @ J ) @ U ) @ M )
          = N ) ) ) )).

% nat_eq_add_iff1
thf(fact_162_add__diff__cancel__right_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel_right'
thf(fact_163_add__diff__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_right
thf(fact_164_add__diff__cancel__left_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ A )
      = B ) )).

% add_diff_cancel_left'
thf(fact_165_add__diff__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_left
thf(fact_166_add__less__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_right
thf(fact_167_add__less__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_left
thf(fact_168_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_169_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_170_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_171_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_172_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_173_mult_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_174_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A2: nat,B2: nat] :
          ( times_times_nat @ B2 @ A2 ) ) )).

% mult.commute
thf(fact_175_mult_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A @ C ) )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_176_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_177_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_178_group__cancel_Oadd1,axiom,(
    ! [A3: nat,K: nat,A: nat,B: nat] :
      ( ( A3
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A3 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_179_group__cancel_Oadd2,axiom,(
    ! [B3: nat,K: nat,B: nat,A: nat] :
      ( ( B3
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B3 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_180_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_181_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A2: nat,B2: nat] :
          ( plus_plus_nat @ B2 @ A2 ) ) )).

% add.commute
thf(fact_182_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_183_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_184_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_185_diff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_186_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_187_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_188_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_189_add__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_mono
thf(fact_190_add__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_left_mono
thf(fact_191_less__eqE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ~ ! [C2: nat] :
            ( B
           != ( plus_plus_nat @ A @ C2 ) ) ) )).

% less_eqE
thf(fact_192_add__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_right_mono
thf(fact_193_le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
        ? [C3: nat] :
          ( B2
          = ( plus_plus_nat @ A2 @ C3 ) ) ) )).

% le_iff_add
thf(fact_194_add__le__imp__le__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_195_add__le__imp__le__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_196_add__mono__thms__linordered__field_I5_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(5)
thf(fact_197_add__mono__thms__linordered__field_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(2)
thf(fact_198_add__mono__thms__linordered__field_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(1)
thf(fact_199_add__strict__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_strict_mono
thf(fact_200_add__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_strict_left_mono
thf(fact_201_add__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_strict_right_mono
thf(fact_202_add__less__imp__less__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_left
thf(fact_203_add__less__imp__less__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_right
thf(fact_204_diff__diff__add,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C )
      = ( minus_minus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% diff_diff_add
thf(fact_205_add__implies__diff,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ( plus_plus_nat @ C @ B )
        = A )
     => ( C
        = ( minus_minus_nat @ A @ B ) ) ) )).

% add_implies_diff
thf(fact_206_min__add__distrib__left,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( plus_plus_nat @ ( ord_min_nat @ X @ Y ) @ Z )
      = ( ord_min_nat @ ( plus_plus_nat @ X @ Z ) @ ( plus_plus_nat @ Y @ Z ) ) ) )).

% min_add_distrib_left
thf(fact_207_min__add__distrib__right,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( plus_plus_nat @ X @ ( ord_min_nat @ Y @ Z ) )
      = ( ord_min_nat @ ( plus_plus_nat @ X @ Y ) @ ( plus_plus_nat @ X @ Z ) ) ) )).

% min_add_distrib_right
thf(fact_208_add__mono__thms__linordered__field_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(4)
thf(fact_209_add__mono__thms__linordered__field_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(3)
thf(fact_210_add__le__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_le_less_mono
thf(fact_211_add__less__le__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_less_le_mono

% Conjectures (3)
thf(conj_0,hypothesis,(
    ~ ( ord_less_nat @ ( size_size_list_a @ xs ) @ k ) )).

thf(conj_1,hypothesis,(
    ord_less_eq_nat @ ( plus_plus_nat @ ( times_times_nat @ m @ k ) @ k ) @ ( size_size_list_a @ xs ) )).

thf(conj_2,conjecture,
    ( ( ord_min_nat @ ( minus_minus_nat @ ( size_size_list_a @ xs ) @ ( times_times_nat @ m @ k ) ) @ k )
    = k )).

%------------------------------------------------------------------------------
