%------------------------------------------------------------------------------
% File     : SLP072^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Number_Partition problem prob_24__5323600_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Number_Partition/prob_24__5323600_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  285 (   2 unit;  23 type;   0 defn)
%            Number of atoms       : 2615 ( 252 equality;1531 variable)
%            Maximal formula depth :   17 (   7 average)
%            Number of connectives : 1928 (  79   ~;  23   |;  44   &;1446   @)
%                                         (   0 <=>; 336  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  106 ( 106   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   26 (  23   :;   0   =)
%            Number of variables   :  708 (   2 sgn; 607   !;   6   ?;  95   ^)
%                                         ( 708   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:41:55.006
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__Set__Oset_It__Set__Oset_It__Nat__Onat_J_J,type,(
    set_set_nat: $tType )).

thf(ty_n_t__Set__Oset_It__Nat__Onat_J,type,(
    set_nat: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (20)
thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_001t__Nat__Onat_001t__Nat__Onat,type,(
    groups1842438620at_nat: ( nat > nat ) > set_nat > nat )).

thf(sy_c_Number__Partition__Mirabelle__zerdlymyoj_Opartitions,type,(
    number1551313001itions: ( nat > nat ) > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Set__Oset_It__Nat__Onat_J,type,(
    ord_less_set_nat: set_nat > set_nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001_062_It__Nat__Onat_M_Eo_J,type,(
    ord_less_eq_nat_o: ( nat > $o ) > ( nat > $o ) > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Set__Oset_It__Nat__Onat_J,type,(
    ord_less_eq_set_nat: set_nat > set_nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Set__Oset_It__Set__Oset_It__Nat__Onat_J_J,type,(
    ord_le1613022364et_nat: set_set_nat > set_set_nat > $o )).

thf(sy_c_Set_OCollect_001t__Nat__Onat,type,(
    collect_nat: ( nat > $o ) > set_nat )).

thf(sy_c_Set_OCollect_001t__Set__Oset_It__Nat__Onat_J,type,(
    collect_set_nat: ( set_nat > $o ) > set_set_nat )).

thf(sy_c_Set__Interval_Oord__class_OatMost_001t__Nat__Onat,type,(
    set_ord_atMost_nat: nat > set_nat )).

thf(sy_c_Set__Interval_Oord__class_OatMost_001t__Set__Oset_It__Nat__Onat_J,type,(
    set_or1086813439et_nat: set_nat > set_set_nat )).

thf(sy_c_member_001t__Nat__Onat,type,(
    member_nat: nat > set_nat > $o )).

thf(sy_c_member_001t__Set__Oset_It__Nat__Onat_J,type,(
    member_set_nat: set_nat > set_set_nat > $o )).

thf(sy_v_n,type,(
    n: nat )).

thf(sy_v_p,type,(
    p: nat > nat )).

thf(sy_v_thesis,type,(
    thesis: $o )).

% Relevant facts (260)
thf(fact_0_assms,axiom,(
    number1551313001itions @ p @ n )).

% assms
thf(fact_1_that,axiom,
    ( ! [I: nat] :
        ( ( ( p @ I )
         != zero_zero_nat )
       => ( ( ord_less_eq_nat @ one_one_nat @ I )
          & ( ord_less_eq_nat @ I @ n ) ) )
   => ( ( ( groups1842438620at_nat
          @ ^ [I2: nat] :
              ( times_times_nat @ ( p @ I2 ) @ I2 )
          @ ( set_ord_atMost_nat @ n ) )
        = n )
     => thesis ) )).

% that
thf(fact_2_sum_Oneutral__const,axiom,(
    ! [A: set_nat] :
      ( ( groups1842438620at_nat
        @ ^ [Uu: nat] : zero_zero_nat
        @ A )
      = zero_zero_nat ) )).

% sum.neutral_const
thf(fact_3_partitionsI,axiom,(
    ! [P: nat > nat,N: nat] :
      ( ! [I: nat] :
          ( ( ( P @ I )
           != zero_zero_nat )
         => ( ( ord_less_eq_nat @ one_one_nat @ I )
            & ( ord_less_eq_nat @ I @ N ) ) )
     => ( ( ( groups1842438620at_nat
            @ ^ [I2: nat] :
                ( times_times_nat @ ( P @ I2 ) @ I2 )
            @ ( set_ord_atMost_nat @ N ) )
          = N )
       => ( number1551313001itions @ P @ N ) ) ) )).

% partitionsI
thf(fact_4_partitions__def,axiom,
    ( number1551313001itions
    = ( ^ [P2: nat > nat,N2: nat] :
          ( ! [I2: nat] :
              ( ( ( P2 @ I2 )
               != zero_zero_nat )
             => ( ( ord_less_eq_nat @ one_one_nat @ I2 )
                & ( ord_less_eq_nat @ I2 @ N2 ) ) )
          & ( ( groups1842438620at_nat
              @ ^ [I2: nat] :
                  ( times_times_nat @ ( P2 @ I2 ) @ I2 )
              @ ( set_ord_atMost_nat @ N2 ) )
            = N2 ) ) ) )).

% partitions_def
thf(fact_5_nat__1__eq__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( one_one_nat
        = ( times_times_nat @ M @ N ) )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_1_eq_mult_iff
thf(fact_6_nat__mult__eq__1__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = one_one_nat )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_mult_eq_1_iff
thf(fact_7_atMost__subset__iff,axiom,(
    ! [X: set_nat,Y: set_nat] :
      ( ( ord_le1613022364et_nat @ ( set_or1086813439et_nat @ X ) @ ( set_or1086813439et_nat @ Y ) )
      = ( ord_less_eq_set_nat @ X @ Y ) ) )).

% atMost_subset_iff
thf(fact_8_atMost__subset__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_set_nat @ ( set_ord_atMost_nat @ X ) @ ( set_ord_atMost_nat @ Y ) )
      = ( ord_less_eq_nat @ X @ Y ) ) )).

% atMost_subset_iff
thf(fact_9_atMost__iff,axiom,(
    ! [I3: set_nat,K: set_nat] :
      ( ( member_set_nat @ I3 @ ( set_or1086813439et_nat @ K ) )
      = ( ord_less_eq_set_nat @ I3 @ K ) ) )).

% atMost_iff
thf(fact_10_atMost__iff,axiom,(
    ! [I3: nat,K: nat] :
      ( ( member_nat @ I3 @ ( set_ord_atMost_nat @ K ) )
      = ( ord_less_eq_nat @ I3 @ K ) ) )).

% atMost_iff
thf(fact_11_mult__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        | ( N = zero_zero_nat ) ) ) )).

% mult_is_0
thf(fact_12_atMost__eq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ( set_ord_atMost_nat @ X )
        = ( set_ord_atMost_nat @ Y ) )
      = ( X = Y ) ) )).

% atMost_eq_iff
thf(fact_13_mult__cancel__right,axiom,(
    ! [A2: nat,C: nat,B: nat] :
      ( ( ( times_times_nat @ A2 @ C )
        = ( times_times_nat @ B @ C ) )
      = ( ( C = zero_zero_nat )
        | ( A2 = B ) ) ) )).

% mult_cancel_right
thf(fact_14_mult__cancel__left,axiom,(
    ! [C: nat,A2: nat,B: nat] :
      ( ( ( times_times_nat @ C @ A2 )
        = ( times_times_nat @ C @ B ) )
      = ( ( C = zero_zero_nat )
        | ( A2 = B ) ) ) )).

% mult_cancel_left
thf(fact_15_mult__eq__0__iff,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ( times_times_nat @ A2 @ B )
        = zero_zero_nat )
      = ( ( A2 = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% mult_eq_0_iff
thf(fact_16_mult__zero__right,axiom,(
    ! [A2: nat] :
      ( ( times_times_nat @ A2 @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_zero_right
thf(fact_17_mult__zero__left,axiom,(
    ! [A2: nat] :
      ( ( times_times_nat @ zero_zero_nat @ A2 )
      = zero_zero_nat ) )).

% mult_zero_left
thf(fact_18_bot__nat__0_Oextremum,axiom,(
    ! [A2: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A2 ) )).

% bot_nat_0.extremum
thf(fact_19_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_20_mult__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times_nat @ M @ K )
        = ( times_times_nat @ N @ K ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel2
thf(fact_21_mult__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel1
thf(fact_22_mult__0__right,axiom,(
    ! [M: nat] :
      ( ( times_times_nat @ M @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_0_right
thf(fact_23_bounded__Max__nat,axiom,(
    ! [P3: nat > $o,X: nat,M2: nat] :
      ( ( P3 @ X )
     => ( ! [X2: nat] :
            ( ( P3 @ X2 )
           => ( ord_less_eq_nat @ X2 @ M2 ) )
       => ~ ! [M3: nat] :
              ( ( P3 @ M3 )
             => ~ ! [X3: nat] :
                    ( ( P3 @ X3 )
                   => ( ord_less_eq_nat @ X3 @ M3 ) ) ) ) ) )).

% bounded_Max_nat
thf(fact_24_Nat_Oex__has__greatest__nat,axiom,(
    ! [P3: nat > $o,K: nat,B: nat] :
      ( ( P3 @ K )
     => ( ! [Y2: nat] :
            ( ( P3 @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P3 @ X2 )
            & ! [Y3: nat] :
                ( ( P3 @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_25_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_26_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_27_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_28_le__trans,axiom,(
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I3 @ K ) ) ) )).

% le_trans
thf(fact_29_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_30_sum_Oreindex__bij__witness,axiom,(
    ! [S: set_nat,I3: nat > nat,J: nat > nat,T: set_nat,H: nat > nat,G: nat > nat] :
      ( ! [A3: nat] :
          ( ( member_nat @ A3 @ S )
         => ( ( I3 @ ( J @ A3 ) )
            = A3 ) )
     => ( ! [A3: nat] :
            ( ( member_nat @ A3 @ S )
           => ( member_nat @ ( J @ A3 ) @ T ) )
       => ( ! [B2: nat] :
              ( ( member_nat @ B2 @ T )
             => ( ( J @ ( I3 @ B2 ) )
                = B2 ) )
         => ( ! [B2: nat] :
                ( ( member_nat @ B2 @ T )
               => ( member_nat @ ( I3 @ B2 ) @ S ) )
           => ( ! [A3: nat] :
                  ( ( member_nat @ A3 @ S )
                 => ( ( H @ ( J @ A3 ) )
                    = ( G @ A3 ) ) )
             => ( ( groups1842438620at_nat @ G @ S )
                = ( groups1842438620at_nat @ H @ T ) ) ) ) ) ) ) )).

% sum.reindex_bij_witness
thf(fact_31_sum_Oeq__general__inverses,axiom,(
    ! [B3: set_nat,K: nat > nat,A: set_nat,H: nat > nat,Gamma: nat > nat,Phi: nat > nat] :
      ( ! [Y2: nat] :
          ( ( member_nat @ Y2 @ B3 )
         => ( ( member_nat @ ( K @ Y2 ) @ A )
            & ( ( H @ ( K @ Y2 ) )
              = Y2 ) ) )
     => ( ! [X2: nat] :
            ( ( member_nat @ X2 @ A )
           => ( ( member_nat @ ( H @ X2 ) @ B3 )
              & ( ( K @ ( H @ X2 ) )
                = X2 )
              & ( ( Gamma @ ( H @ X2 ) )
                = ( Phi @ X2 ) ) ) )
       => ( ( groups1842438620at_nat @ Phi @ A )
          = ( groups1842438620at_nat @ Gamma @ B3 ) ) ) ) )).

% sum.eq_general_inverses
thf(fact_32_sum_Oeq__general,axiom,(
    ! [B3: set_nat,A: set_nat,H: nat > nat,Gamma: nat > nat,Phi: nat > nat] :
      ( ! [Y2: nat] :
          ( ( member_nat @ Y2 @ B3 )
         => ? [X3: nat] :
              ( ( member_nat @ X3 @ A )
              & ( ( H @ X3 )
                = Y2 )
              & ! [Ya: nat] :
                  ( ( ( member_nat @ Ya @ A )
                    & ( ( H @ Ya )
                      = Y2 ) )
                 => ( Ya = X3 ) ) ) )
     => ( ! [X2: nat] :
            ( ( member_nat @ X2 @ A )
           => ( ( member_nat @ ( H @ X2 ) @ B3 )
              & ( ( Gamma @ ( H @ X2 ) )
                = ( Phi @ X2 ) ) ) )
       => ( ( groups1842438620at_nat @ Phi @ A )
          = ( groups1842438620at_nat @ Gamma @ B3 ) ) ) ) )).

% sum.eq_general
thf(fact_33_sum_Ocong,axiom,(
    ! [A: set_nat,B3: set_nat,G: nat > nat,H: nat > nat] :
      ( ( A = B3 )
     => ( ! [X2: nat] :
            ( ( member_nat @ X2 @ B3 )
           => ( ( G @ X2 )
              = ( H @ X2 ) ) )
       => ( ( groups1842438620at_nat @ G @ A )
          = ( groups1842438620at_nat @ H @ B3 ) ) ) ) )).

% sum.cong
thf(fact_34_sum_Oswap,axiom,(
    ! [G: nat > nat > nat,B3: set_nat,A: set_nat] :
      ( ( groups1842438620at_nat
        @ ^ [I2: nat] :
            ( groups1842438620at_nat @ ( G @ I2 ) @ B3 )
        @ A )
      = ( groups1842438620at_nat
        @ ^ [J2: nat] :
            ( groups1842438620at_nat
            @ ^ [I2: nat] :
                ( G @ I2 @ J2 )
            @ A )
        @ B3 ) ) )).

% sum.swap
thf(fact_35_mult__right__cancel,axiom,(
    ! [C: nat,A2: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ A2 @ C )
          = ( times_times_nat @ B @ C ) )
        = ( A2 = B ) ) ) )).

% mult_right_cancel
thf(fact_36_mult__left__cancel,axiom,(
    ! [C: nat,A2: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ C @ A2 )
          = ( times_times_nat @ C @ B ) )
        = ( A2 = B ) ) ) )).

% mult_left_cancel
thf(fact_37_no__zero__divisors,axiom,(
    ! [A2: nat,B: nat] :
      ( ( A2 != zero_zero_nat )
     => ( ( B != zero_zero_nat )
       => ( ( times_times_nat @ A2 @ B )
         != zero_zero_nat ) ) ) )).

% no_zero_divisors
thf(fact_38_divisors__zero,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ( times_times_nat @ A2 @ B )
        = zero_zero_nat )
     => ( ( A2 = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% divisors_zero
thf(fact_39_mult__not__zero,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ( times_times_nat @ A2 @ B )
       != zero_zero_nat )
     => ( ( A2 != zero_zero_nat )
        & ( B != zero_zero_nat ) ) ) )).

% mult_not_zero
thf(fact_40_zero__neq__one,axiom,(
    zero_zero_nat != one_one_nat )).

% zero_neq_one
thf(fact_41_sum_Onot__neutral__contains__not__neutral,axiom,(
    ! [G: nat > nat,A: set_nat] :
      ( ( ( groups1842438620at_nat @ G @ A )
       != zero_zero_nat )
     => ~ ! [A3: nat] :
            ( ( member_nat @ A3 @ A )
           => ( ( G @ A3 )
              = zero_zero_nat ) ) ) )).

% sum.not_neutral_contains_not_neutral
thf(fact_42_mem__Collect__eq,axiom,(
    ! [A2: nat,P3: nat > $o] :
      ( ( member_nat @ A2 @ ( collect_nat @ P3 ) )
      = ( P3 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_43_Collect__mem__eq,axiom,(
    ! [A: set_nat] :
      ( ( collect_nat
        @ ^ [X4: nat] :
            ( member_nat @ X4 @ A ) )
      = A ) )).

% Collect_mem_eq
thf(fact_44_Collect__cong,axiom,(
    ! [P3: nat > $o,Q: nat > $o] :
      ( ! [X2: nat] :
          ( ( P3 @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect_nat @ P3 )
        = ( collect_nat @ Q ) ) ) )).

% Collect_cong
thf(fact_45_sum_Oneutral,axiom,(
    ! [A: set_nat,G: nat > nat] :
      ( ! [X2: nat] :
          ( ( member_nat @ X2 @ A )
         => ( ( G @ X2 )
            = zero_zero_nat ) )
     => ( ( groups1842438620at_nat @ G @ A )
        = zero_zero_nat ) ) )).

% sum.neutral
thf(fact_46_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A2: nat] :
      ( ( ord_less_eq_nat @ A2 @ zero_zero_nat )
     => ( A2 = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_47_bot__nat__0_Oextremum__unique,axiom,(
    ! [A2: nat] :
      ( ( ord_less_eq_nat @ A2 @ zero_zero_nat )
      = ( A2 = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_48_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_49_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_50_mult__0,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% mult_0
thf(fact_51_mult__le__mono2,axiom,(
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ K @ I3 ) @ ( times_times_nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_52_mult__le__mono1,axiom,(
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ I3 @ K ) @ ( times_times_nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_53_mult__le__mono,axiom,(
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I3 @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( times_times_nat @ I3 @ K ) @ ( times_times_nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_54_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ M ) ) )).

% le_square
thf(fact_55_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ ( times_times_nat @ M @ M ) ) ) )).

% le_cube
thf(fact_56_nat__mult__1__right,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ N @ one_one_nat )
      = N ) )).

% nat_mult_1_right
thf(fact_57_nat__mult__1,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ one_one_nat @ N )
      = N ) )).

% nat_mult_1
thf(fact_58_lambda__zero,axiom,
    ( ( ^ [H2: nat] : zero_zero_nat )
    = ( times_times_nat @ zero_zero_nat ) )).

% lambda_zero
thf(fact_59_lambda__one,axiom,
    ( ( ^ [X4: nat] : X4 )
    = ( times_times_nat @ one_one_nat ) )).

% lambda_one
thf(fact_60_sum__mono,axiom,(
    ! [K2: set_nat,F: nat > nat,G: nat > nat] :
      ( ! [I: nat] :
          ( ( member_nat @ I @ K2 )
         => ( ord_less_eq_nat @ ( F @ I ) @ ( G @ I ) ) )
     => ( ord_less_eq_nat @ ( groups1842438620at_nat @ F @ K2 ) @ ( groups1842438620at_nat @ G @ K2 ) ) ) )).

% sum_mono
thf(fact_61_sum__distrib__right,axiom,(
    ! [F: nat > nat,A: set_nat,R: nat] :
      ( ( times_times_nat @ ( groups1842438620at_nat @ F @ A ) @ R )
      = ( groups1842438620at_nat
        @ ^ [N2: nat] :
            ( times_times_nat @ ( F @ N2 ) @ R )
        @ A ) ) )).

% sum_distrib_right
thf(fact_62_sum__distrib__left,axiom,(
    ! [R: nat,F: nat > nat,A: set_nat] :
      ( ( times_times_nat @ R @ ( groups1842438620at_nat @ F @ A ) )
      = ( groups1842438620at_nat
        @ ^ [N2: nat] :
            ( times_times_nat @ R @ ( F @ N2 ) )
        @ A ) ) )).

% sum_distrib_left
thf(fact_63_sum__product,axiom,(
    ! [F: nat > nat,A: set_nat,G: nat > nat,B3: set_nat] :
      ( ( times_times_nat @ ( groups1842438620at_nat @ F @ A ) @ ( groups1842438620at_nat @ G @ B3 ) )
      = ( groups1842438620at_nat
        @ ^ [I2: nat] :
            ( groups1842438620at_nat
            @ ^ [J2: nat] :
                ( times_times_nat @ ( F @ I2 ) @ ( G @ J2 ) )
            @ B3 )
        @ A ) ) )).

% sum_product
thf(fact_64_atMost__def,axiom,
    ( set_or1086813439et_nat
    = ( ^ [U: set_nat] :
          ( collect_set_nat
          @ ^ [X4: set_nat] :
              ( ord_less_eq_set_nat @ X4 @ U ) ) ) )).

% atMost_def
thf(fact_65_atMost__def,axiom,
    ( set_ord_atMost_nat
    = ( ^ [U: nat] :
          ( collect_nat
          @ ^ [X4: nat] :
              ( ord_less_eq_nat @ X4 @ U ) ) ) )).

% atMost_def
thf(fact_66_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A2 ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_67_mult__nonneg__nonpos2,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A2 )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ B @ A2 ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_68_mult__nonpos__nonneg,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_eq_nat @ A2 @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ ( times_times_nat @ A2 @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonpos_nonneg
thf(fact_69_mult__nonneg__nonpos,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A2 )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ A2 @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos
thf(fact_70_mult__nonneg__nonneg,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A2 )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( times_times_nat @ A2 @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_71_split__mult__neg__le,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ( ( ord_less_eq_nat @ zero_zero_nat @ A2 )
          & ( ord_less_eq_nat @ B @ zero_zero_nat ) )
        | ( ( ord_less_eq_nat @ A2 @ zero_zero_nat )
          & ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )
     => ( ord_less_eq_nat @ ( times_times_nat @ A2 @ B ) @ zero_zero_nat ) ) )).

% split_mult_neg_le
thf(fact_72_mult__right__mono,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ A2 @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_73_mult__left__mono,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A2 ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_74_mult__mono_H,axiom,(
    ! [A2: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A2 )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A2 @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_75_mult__mono,axiom,(
    ! [A2: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A2 @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_76_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_le_zero
thf(fact_77_zero__le__one,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ one_one_nat )).

% zero_le_one
thf(fact_78_sum__nonpos,axiom,(
    ! [A: set_nat,F: nat > nat] :
      ( ! [X2: nat] :
          ( ( member_nat @ X2 @ A )
         => ( ord_less_eq_nat @ ( F @ X2 ) @ zero_zero_nat ) )
     => ( ord_less_eq_nat @ ( groups1842438620at_nat @ F @ A ) @ zero_zero_nat ) ) )).

% sum_nonpos
thf(fact_79_sum__nonneg,axiom,(
    ! [A: set_nat,F: nat > nat] :
      ( ! [X2: nat] :
          ( ( member_nat @ X2 @ A )
         => ( ord_less_eq_nat @ zero_zero_nat @ ( F @ X2 ) ) )
     => ( ord_less_eq_nat @ zero_zero_nat @ ( groups1842438620at_nat @ F @ A ) ) ) )).

% sum_nonneg
thf(fact_80_mult__eq__self__implies__10,axiom,(
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times_nat @ M @ N ) )
     => ( ( N = one_one_nat )
        | ( M = zero_zero_nat ) ) ) )).

% mult_eq_self_implies_10
thf(fact_81_mult__left__le,axiom,(
    ! [C: nat,A2: nat] :
      ( ( ord_less_eq_nat @ C @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A2 )
       => ( ord_less_eq_nat @ ( times_times_nat @ A2 @ C ) @ A2 ) ) ) )).

% mult_left_le
thf(fact_82_mult__le__one,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_eq_nat @ A2 @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ( ord_less_eq_nat @ B @ one_one_nat )
         => ( ord_less_eq_nat @ ( times_times_nat @ A2 @ B ) @ one_one_nat ) ) ) ) )).

% mult_le_one
thf(fact_83_mult_Oright__neutral,axiom,(
    ! [A2: nat] :
      ( ( times_times_nat @ A2 @ one_one_nat )
      = A2 ) )).

% mult.right_neutral
thf(fact_84_mult_Oleft__neutral,axiom,(
    ! [A2: nat] :
      ( ( times_times_nat @ one_one_nat @ A2 )
      = A2 ) )).

% mult.left_neutral
thf(fact_85_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_86_subsetI,axiom,(
    ! [A: set_nat,B3: set_nat] :
      ( ! [X2: nat] :
          ( ( member_nat @ X2 @ A )
         => ( member_nat @ X2 @ B3 ) )
     => ( ord_less_eq_set_nat @ A @ B3 ) ) )).

% subsetI
thf(fact_87_subset__antisym,axiom,(
    ! [A: set_nat,B3: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B3 )
     => ( ( ord_less_eq_set_nat @ B3 @ A )
       => ( A = B3 ) ) ) )).

% subset_antisym
thf(fact_88_order__refl,axiom,(
    ! [X: set_nat] :
      ( ord_less_eq_set_nat @ X @ X ) )).

% order_refl
thf(fact_89_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_90_nat__mult__eq__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( K = zero_zero_nat )
        | ( M = N ) ) ) )).

% nat_mult_eq_cancel_disj
thf(fact_91_mult_Ocomm__neutral,axiom,(
    ! [A2: nat] :
      ( ( times_times_nat @ A2 @ one_one_nat )
      = A2 ) )).

% mult.comm_neutral
thf(fact_92_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A2: nat] :
      ( ( times_times_nat @ one_one_nat @ A2 )
      = A2 ) )).

% comm_monoid_mult_class.mult_1
thf(fact_93_order__subst1,axiom,(
    ! [A2: nat,F: set_nat > nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A2 @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_94_order__subst1,axiom,(
    ! [A2: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A2 @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_95_order__subst1,axiom,(
    ! [A2: set_nat,F: set_nat > set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A2 @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_96_order__subst1,axiom,(
    ! [A2: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A2 @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_97_order__subst2,axiom,(
    ! [A2: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ord_less_eq_set_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% order_subst2
thf(fact_98_order__subst2,axiom,(
    ! [A2: set_nat,B: set_nat,F: set_nat > nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% order_subst2
thf(fact_99_order__subst2,axiom,(
    ! [A2: set_nat,B: set_nat,F: set_nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B )
     => ( ( ord_less_eq_set_nat @ ( F @ B ) @ C )
       => ( ! [X2: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% order_subst2
thf(fact_100_order__subst2,axiom,(
    ! [A2: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% order_subst2
thf(fact_101_ord__eq__le__subst,axiom,(
    ! [A2: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( A2
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_102_ord__eq__le__subst,axiom,(
    ! [A2: nat,F: set_nat > nat,B: set_nat,C: set_nat] :
      ( ( A2
        = ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_103_ord__eq__le__subst,axiom,(
    ! [A2: set_nat,F: set_nat > set_nat,B: set_nat,C: set_nat] :
      ( ( A2
        = ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X2: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_104_ord__eq__le__subst,axiom,(
    ! [A2: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A2
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_105_ord__le__eq__subst,axiom,(
    ! [A2: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_106_ord__le__eq__subst,axiom,(
    ! [A2: set_nat,B: set_nat,F: set_nat > nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_107_ord__le__eq__subst,axiom,(
    ! [A2: set_nat,B: set_nat,F: set_nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X2 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_108_ord__le__eq__subst,axiom,(
    ! [A2: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_109_eq__iff,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [X4: set_nat,Y5: set_nat] :
          ( ( ord_less_eq_set_nat @ X4 @ Y5 )
          & ( ord_less_eq_set_nat @ Y5 @ X4 ) ) ) )).

% eq_iff
thf(fact_110_eq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X4 ) ) ) )).

% eq_iff
thf(fact_111_antisym,axiom,(
    ! [X: set_nat,Y: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y )
     => ( ( ord_less_eq_set_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_112_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_113_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_114_eq__refl,axiom,(
    ! [X: set_nat,Y: set_nat] :
      ( ( X = Y )
     => ( ord_less_eq_set_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_115_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_116_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_117_order_Otrans,axiom,(
    ! [A2: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_eq_set_nat @ A2 @ C ) ) ) )).

% order.trans
thf(fact_118_order_Otrans,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A2 @ C ) ) ) )).

% order.trans
thf(fact_119_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_120_antisym__conv,axiom,(
    ! [Y: set_nat,X: set_nat] :
      ( ( ord_less_eq_set_nat @ Y @ X )
     => ( ( ord_less_eq_set_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_121_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_122_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [A4: set_nat,B4: set_nat] :
          ( ( ord_less_eq_set_nat @ A4 @ B4 )
          & ( ord_less_eq_set_nat @ B4 @ A4 ) ) ) )).

% order_class.order.eq_iff
thf(fact_123_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ A4 @ B4 )
          & ( ord_less_eq_nat @ B4 @ A4 ) ) ) )).

% order_class.order.eq_iff
thf(fact_124_ord__eq__le__trans,axiom,(
    ! [A2: set_nat,B: set_nat,C: set_nat] :
      ( ( A2 = B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_eq_set_nat @ A2 @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_125_ord__eq__le__trans,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( A2 = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A2 @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_126_ord__le__eq__trans,axiom,(
    ! [A2: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B )
     => ( ( B = C )
       => ( ord_less_eq_set_nat @ A2 @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_127_ord__le__eq__trans,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A2 @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_128_order__class_Oorder_Oantisym,axiom,(
    ! [A2: set_nat,B: set_nat] :
      ( ( ord_less_eq_set_nat @ A2 @ B )
     => ( ( ord_less_eq_set_nat @ B @ A2 )
       => ( A2 = B ) ) ) )).

% order_class.order.antisym
thf(fact_129_order__class_Oorder_Oantisym,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_eq_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ B @ A2 )
       => ( A2 = B ) ) ) )).

% order_class.order.antisym
thf(fact_130_order__trans,axiom,(
    ! [X: set_nat,Y: set_nat,Z2: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y )
     => ( ( ord_less_eq_set_nat @ Y @ Z2 )
       => ( ord_less_eq_set_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_131_order__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_132_dual__order_Orefl,axiom,(
    ! [A2: set_nat] :
      ( ord_less_eq_set_nat @ A2 @ A2 ) )).

% dual_order.refl
thf(fact_133_dual__order_Orefl,axiom,(
    ! [A2: nat] :
      ( ord_less_eq_nat @ A2 @ A2 ) )).

% dual_order.refl
thf(fact_134_linorder__wlog,axiom,(
    ! [P3: nat > nat > $o,A2: nat,B: nat] :
      ( ! [A3: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A3 @ B2 )
         => ( P3 @ A3 @ B2 ) )
     => ( ! [A3: nat,B2: nat] :
            ( ( P3 @ B2 @ A3 )
           => ( P3 @ A3 @ B2 ) )
       => ( P3 @ A2 @ B ) ) ) )).

% linorder_wlog
thf(fact_135_dual__order_Otrans,axiom,(
    ! [B: set_nat,A2: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A2 )
     => ( ( ord_less_eq_set_nat @ C @ B )
       => ( ord_less_eq_set_nat @ C @ A2 ) ) ) )).

% dual_order.trans
thf(fact_136_dual__order_Otrans,axiom,(
    ! [B: nat,A2: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A2 )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A2 ) ) ) )).

% dual_order.trans
thf(fact_137_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [A4: set_nat,B4: set_nat] :
          ( ( ord_less_eq_set_nat @ B4 @ A4 )
          & ( ord_less_eq_set_nat @ A4 @ B4 ) ) ) )).

% dual_order.eq_iff
thf(fact_138_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ B4 @ A4 )
          & ( ord_less_eq_nat @ A4 @ B4 ) ) ) )).

% dual_order.eq_iff
thf(fact_139_dual__order_Oantisym,axiom,(
    ! [B: set_nat,A2: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A2 )
     => ( ( ord_less_eq_set_nat @ A2 @ B )
       => ( A2 = B ) ) ) )).

% dual_order.antisym
thf(fact_140_dual__order_Oantisym,axiom,(
    ! [B: nat,A2: nat] :
      ( ( ord_less_eq_nat @ B @ A2 )
     => ( ( ord_less_eq_nat @ A2 @ B )
       => ( A2 = B ) ) ) )).

% dual_order.antisym
thf(fact_141_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_142_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A2 @ B ) @ C )
      = ( times_times_nat @ A2 @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_143_mult_Oassoc,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A2 @ B ) @ C )
      = ( times_times_nat @ A2 @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_144_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A4: nat,B4: nat] :
          ( times_times_nat @ B4 @ A4 ) ) )).

% mult.commute
thf(fact_145_mult_Oleft__commute,axiom,(
    ! [B: nat,A2: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A2 @ C ) )
      = ( times_times_nat @ A2 @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_146_one__reorient,axiom,(
    ! [X: nat] :
      ( ( one_one_nat = X )
      = ( X = one_one_nat ) ) )).

% one_reorient
thf(fact_147_Collect__mono__iff,axiom,(
    ! [P3: nat > $o,Q: nat > $o] :
      ( ( ord_less_eq_set_nat @ ( collect_nat @ P3 ) @ ( collect_nat @ Q ) )
      = ( ! [X4: nat] :
            ( ( P3 @ X4 )
           => ( Q @ X4 ) ) ) ) )).

% Collect_mono_iff
thf(fact_148_set__eq__subset,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [A5: set_nat,B5: set_nat] :
          ( ( ord_less_eq_set_nat @ A5 @ B5 )
          & ( ord_less_eq_set_nat @ B5 @ A5 ) ) ) )).

% set_eq_subset
thf(fact_149_subset__trans,axiom,(
    ! [A: set_nat,B3: set_nat,C2: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B3 )
     => ( ( ord_less_eq_set_nat @ B3 @ C2 )
       => ( ord_less_eq_set_nat @ A @ C2 ) ) ) )).

% subset_trans
thf(fact_150_Collect__mono,axiom,(
    ! [P3: nat > $o,Q: nat > $o] :
      ( ! [X2: nat] :
          ( ( P3 @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq_set_nat @ ( collect_nat @ P3 ) @ ( collect_nat @ Q ) ) ) )).

% Collect_mono
thf(fact_151_subset__refl,axiom,(
    ! [A: set_nat] :
      ( ord_less_eq_set_nat @ A @ A ) )).

% subset_refl
thf(fact_152_subset__iff,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
        ! [T2: nat] :
          ( ( member_nat @ T2 @ A5 )
         => ( member_nat @ T2 @ B5 ) ) ) )).

% subset_iff
thf(fact_153_equalityD2,axiom,(
    ! [A: set_nat,B3: set_nat] :
      ( ( A = B3 )
     => ( ord_less_eq_set_nat @ B3 @ A ) ) )).

% equalityD2
thf(fact_154_equalityD1,axiom,(
    ! [A: set_nat,B3: set_nat] :
      ( ( A = B3 )
     => ( ord_less_eq_set_nat @ A @ B3 ) ) )).

% equalityD1
thf(fact_155_subset__eq,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
        ! [X4: nat] :
          ( ( member_nat @ X4 @ A5 )
         => ( member_nat @ X4 @ B5 ) ) ) )).

% subset_eq
thf(fact_156_equalityE,axiom,(
    ! [A: set_nat,B3: set_nat] :
      ( ( A = B3 )
     => ~ ( ( ord_less_eq_set_nat @ A @ B3 )
         => ~ ( ord_less_eq_set_nat @ B3 @ A ) ) ) )).

% equalityE
thf(fact_157_subsetD,axiom,(
    ! [A: set_nat,B3: set_nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ B3 )
     => ( ( member_nat @ C @ A )
       => ( member_nat @ C @ B3 ) ) ) )).

% subsetD
thf(fact_158_in__mono,axiom,(
    ! [A: set_nat,B3: set_nat,X: nat] :
      ( ( ord_less_eq_set_nat @ A @ B3 )
     => ( ( member_nat @ X @ A )
       => ( member_nat @ X @ B3 ) ) ) )).

% in_mono
thf(fact_159_less__eq__set__def,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
          ( ord_less_eq_nat_o
          @ ^ [X4: nat] :
              ( member_nat @ X4 @ A5 )
          @ ^ [X4: nat] :
              ( member_nat @ X4 @ B5 ) ) ) )).

% less_eq_set_def
thf(fact_160_Collect__subset,axiom,(
    ! [A: set_nat,P3: nat > $o] :
      ( ord_less_eq_set_nat
      @ ( collect_nat
        @ ^ [X4: nat] :
            ( ( member_nat @ X4 @ A )
            & ( P3 @ X4 ) ) )
      @ A ) )).

% Collect_subset
thf(fact_161_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_162_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_nat @ one_one_nat @ one_one_nat )).

% le_numeral_extra(4)
thf(fact_163_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_164_subset__Collect__iff,axiom,(
    ! [B3: set_nat,A: set_nat,P3: nat > $o] :
      ( ( ord_less_eq_set_nat @ B3 @ A )
     => ( ( ord_less_eq_set_nat @ B3
          @ ( collect_nat
            @ ^ [X4: nat] :
                ( ( member_nat @ X4 @ A )
                & ( P3 @ X4 ) ) ) )
        = ( ! [X4: nat] :
              ( ( member_nat @ X4 @ B3 )
             => ( P3 @ X4 ) ) ) ) ) )).

% subset_Collect_iff
thf(fact_165_subset__CollectI,axiom,(
    ! [B3: set_nat,A: set_nat,Q: nat > $o,P3: nat > $o] :
      ( ( ord_less_eq_set_nat @ B3 @ A )
     => ( ! [X2: nat] :
            ( ( member_nat @ X2 @ B3 )
           => ( ( Q @ X2 )
             => ( P3 @ X2 ) ) )
       => ( ord_less_eq_set_nat
          @ ( collect_nat
            @ ^ [X4: nat] :
                ( ( member_nat @ X4 @ B3 )
                & ( Q @ X4 ) ) )
          @ ( collect_nat
            @ ^ [X4: nat] :
                ( ( member_nat @ X4 @ A )
                & ( P3 @ X4 ) ) ) ) ) ) )).

% subset_CollectI
thf(fact_166_Collect__restrict,axiom,(
    ! [X5: set_nat,P3: nat > $o] :
      ( ord_less_eq_set_nat
      @ ( collect_nat
        @ ^ [X4: nat] :
            ( ( member_nat @ X4 @ X5 )
            & ( P3 @ X4 ) ) )
      @ X5 ) )).

% Collect_restrict
thf(fact_167_prop__restrict,axiom,(
    ! [X: nat,Z3: set_nat,X5: set_nat,P3: nat > $o] :
      ( ( member_nat @ X @ Z3 )
     => ( ( ord_less_eq_set_nat @ Z3
          @ ( collect_nat
            @ ^ [X4: nat] :
                ( ( member_nat @ X4 @ X5 )
                & ( P3 @ X4 ) ) ) )
       => ( P3 @ X ) ) ) )).

% prop_restrict
thf(fact_168_pred__subset__eq,axiom,(
    ! [R2: set_nat,S: set_nat] :
      ( ( ord_less_eq_nat_o
        @ ^ [X4: nat] :
            ( member_nat @ X4 @ R2 )
        @ ^ [X4: nat] :
            ( member_nat @ X4 @ S ) )
      = ( ord_less_eq_set_nat @ R2 @ S ) ) )).

% pred_subset_eq
thf(fact_169_conj__subset__def,axiom,(
    ! [A: set_nat,P3: nat > $o,Q: nat > $o] :
      ( ( ord_less_eq_set_nat @ A
        @ ( collect_nat
          @ ^ [X4: nat] :
              ( ( P3 @ X4 )
              & ( Q @ X4 ) ) ) )
      = ( ( ord_less_eq_set_nat @ A @ ( collect_nat @ P3 ) )
        & ( ord_less_eq_set_nat @ A @ ( collect_nat @ Q ) ) ) ) )).

% conj_subset_def
thf(fact_170_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_171_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_172_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A2: nat] :
      ( ( A2 != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A2 ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_173_psubsetI,axiom,(
    ! [A: set_nat,B3: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B3 )
     => ( ( A != B3 )
       => ( ord_less_set_nat @ A @ B3 ) ) ) )).

% psubsetI
thf(fact_174_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_175_nat__0__less__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ M @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ M )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% nat_0_less_mult_iff
thf(fact_176_mult__less__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% mult_less_cancel2
thf(fact_177_nat__mult__less__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% nat_mult_less_cancel_disj
thf(fact_178_less__one,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ one_one_nat )
      = ( N = zero_zero_nat ) ) )).

% less_one
thf(fact_179_mult__le__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% mult_le_cancel2
thf(fact_180_nat__mult__le__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_mult_le_cancel_disj
thf(fact_181_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A2: nat] :
      ( ( ord_less_nat @ B @ A2 )
     => ( A2 != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_182_order_Ostrict__implies__not__eq,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_nat @ A2 @ B )
     => ( A2 != B ) ) )).

% order.strict_implies_not_eq
thf(fact_183_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_184_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A2: nat,C: nat] :
      ( ( ord_less_nat @ B @ A2 )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A2 ) ) ) )).

% dual_order.strict_trans
thf(fact_185_linorder__less__wlog,axiom,(
    ! [P3: nat > nat > $o,A2: nat,B: nat] :
      ( ! [A3: nat,B2: nat] :
          ( ( ord_less_nat @ A3 @ B2 )
         => ( P3 @ A3 @ B2 ) )
     => ( ! [A3: nat] :
            ( P3 @ A3 @ A3 )
       => ( ! [A3: nat,B2: nat] :
              ( ( P3 @ B2 @ A3 )
             => ( P3 @ A3 @ B2 ) )
         => ( P3 @ A2 @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_186_exists__least__iff,axiom,
    ( ( ^ [P4: nat > $o] :
        ? [X6: nat] :
          ( P4 @ X6 ) )
    = ( ^ [P5: nat > $o] :
        ? [N2: nat] :
          ( ( P5 @ N2 )
          & ! [M4: nat] :
              ( ( ord_less_nat @ M4 @ N2 )
             => ~ ( P5 @ M4 ) ) ) ) )).

% exists_least_iff
thf(fact_187_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_188_order_Ostrict__trans,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A2 @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A2 @ C ) ) ) )).

% order.strict_trans
thf(fact_189_dual__order_Oirrefl,axiom,(
    ! [A2: nat] :
      ~ ( ord_less_nat @ A2 @ A2 ) )).

% dual_order.irrefl
thf(fact_190_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_191_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P3: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P3 ) ) )).

% less_imp_triv
thf(fact_192_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_193_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_194_less__induct,axiom,(
    ! [P3: nat > $o,A2: nat] :
      ( ! [X2: nat] :
          ( ! [Y3: nat] :
              ( ( ord_less_nat @ Y3 @ X2 )
             => ( P3 @ Y3 ) )
         => ( P3 @ X2 ) )
     => ( P3 @ A2 ) ) )).

% less_induct
thf(fact_195_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_196_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_197_dual__order_Oasym,axiom,(
    ! [B: nat,A2: nat] :
      ( ( ord_less_nat @ B @ A2 )
     => ~ ( ord_less_nat @ A2 @ B ) ) )).

% dual_order.asym
thf(fact_198_ord__less__eq__trans,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A2 @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A2 @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_199_ord__eq__less__trans,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( A2 = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A2 @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_200_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_201_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_202_less__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_203_less__asym_H,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_nat @ A2 @ B )
     => ~ ( ord_less_nat @ B @ A2 ) ) )).

% less_asym'
thf(fact_204_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_205_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_206_order_Oasym,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_nat @ A2 @ B )
     => ~ ( ord_less_nat @ B @ A2 ) ) )).

% order.asym
thf(fact_207_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_208_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_209_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_210_order__less__subst2,axiom,(
    ! [A2: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A2 @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_211_order__less__subst1,axiom,(
    ! [A2: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A2 @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_212_ord__less__eq__subst,axiom,(
    ! [A2: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A2 @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A2 ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_213_ord__eq__less__subst,axiom,(
    ! [A2: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A2
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A2 @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_214_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_215_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_216_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_217_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_218_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_219_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_220_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_221_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_222_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_223_infinite__descent0,axiom,(
    ! [P3: nat > $o,N: nat] :
      ( ( P3 @ zero_zero_nat )
     => ( ! [N3: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N3 )
           => ( ~ ( P3 @ N3 )
             => ? [M5: nat] :
                  ( ( ord_less_nat @ M5 @ N3 )
                  & ~ ( P3 @ M5 ) ) ) )
       => ( P3 @ N ) ) ) )).

% infinite_descent0
thf(fact_224_bot__nat__0_Oextremum__strict,axiom,(
    ! [A2: nat] :
      ~ ( ord_less_nat @ A2 @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_225_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M4: nat,N2: nat] :
          ( ( ord_less_eq_nat @ M4 @ N2 )
          & ( M4 != N2 ) ) ) )).

% nat_less_le
thf(fact_226_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_227_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M4: nat,N2: nat] :
          ( ( ord_less_nat @ M4 @ N2 )
          | ( M4 = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_228_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_229_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_230_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I3: nat,J: nat] :
      ( ! [I: nat,J3: nat] :
          ( ( ord_less_nat @ I @ J3 )
         => ( ord_less_nat @ ( F @ I ) @ ( F @ J3 ) ) )
     => ( ( ord_less_eq_nat @ I3 @ J )
       => ( ord_less_eq_nat @ ( F @ I3 ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_231_psubsetE,axiom,(
    ! [A: set_nat,B3: set_nat] :
      ( ( ord_less_set_nat @ A @ B3 )
     => ~ ( ( ord_less_eq_set_nat @ A @ B3 )
         => ( ord_less_eq_set_nat @ B3 @ A ) ) ) )).

% psubsetE
thf(fact_232_psubset__eq,axiom,
    ( ord_less_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
          ( ( ord_less_eq_set_nat @ A5 @ B5 )
          & ( A5 != B5 ) ) ) )).

% psubset_eq
thf(fact_233_psubset__imp__subset,axiom,(
    ! [A: set_nat,B3: set_nat] :
      ( ( ord_less_set_nat @ A @ B3 )
     => ( ord_less_eq_set_nat @ A @ B3 ) ) )).

% psubset_imp_subset
thf(fact_234_psubset__subset__trans,axiom,(
    ! [A: set_nat,B3: set_nat,C2: set_nat] :
      ( ( ord_less_set_nat @ A @ B3 )
     => ( ( ord_less_eq_set_nat @ B3 @ C2 )
       => ( ord_less_set_nat @ A @ C2 ) ) ) )).

% psubset_subset_trans
thf(fact_235_subset__not__subset__eq,axiom,
    ( ord_less_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
          ( ( ord_less_eq_set_nat @ A5 @ B5 )
          & ~ ( ord_less_eq_set_nat @ B5 @ A5 ) ) ) )).

% subset_not_subset_eq
thf(fact_236_subset__psubset__trans,axiom,(
    ! [A: set_nat,B3: set_nat,C2: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B3 )
     => ( ( ord_less_set_nat @ B3 @ C2 )
       => ( ord_less_set_nat @ A @ C2 ) ) ) )).

% subset_psubset_trans
thf(fact_237_subset__iff__psubset__eq,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A5: set_nat,B5: set_nat] :
          ( ( ord_less_set_nat @ A5 @ B5 )
          | ( A5 = B5 ) ) ) )).

% subset_iff_psubset_eq
thf(fact_238_less__numeral__extra_I4_J,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ one_one_nat ) )).

% less_numeral_extra(4)
thf(fact_239_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_240_order_Onot__eq__order__implies__strict,axiom,(
    ! [A2: set_nat,B: set_nat] :
      ( ( A2 != B )
     => ( ( ord_less_eq_set_nat @ A2 @ B )
       => ( ord_less_set_nat @ A2 @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_241_order_Onot__eq__order__implies__strict,axiom,(
    ! [A2: nat,B: nat] :
      ( ( A2 != B )
     => ( ( ord_less_eq_nat @ A2 @ B )
       => ( ord_less_nat @ A2 @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_242_dual__order_Ostrict__implies__order,axiom,(
    ! [B: set_nat,A2: set_nat] :
      ( ( ord_less_set_nat @ B @ A2 )
     => ( ord_less_eq_set_nat @ B @ A2 ) ) )).

% dual_order.strict_implies_order
thf(fact_243_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A2: nat] :
      ( ( ord_less_nat @ B @ A2 )
     => ( ord_less_eq_nat @ B @ A2 ) ) )).

% dual_order.strict_implies_order
thf(fact_244_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_set_nat
    = ( ^ [B4: set_nat,A4: set_nat] :
          ( ( ord_less_eq_set_nat @ B4 @ A4 )
          & ( A4 != B4 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_245_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B4: nat,A4: nat] :
          ( ( ord_less_eq_nat @ B4 @ A4 )
          & ( A4 != B4 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_246_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [B4: set_nat,A4: set_nat] :
          ( ( ord_less_set_nat @ B4 @ A4 )
          | ( A4 = B4 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_247_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B4: nat,A4: nat] :
          ( ( ord_less_nat @ B4 @ A4 )
          | ( A4 = B4 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_248_order_Ostrict__implies__order,axiom,(
    ! [A2: set_nat,B: set_nat] :
      ( ( ord_less_set_nat @ A2 @ B )
     => ( ord_less_eq_set_nat @ A2 @ B ) ) )).

% order.strict_implies_order
thf(fact_249_order_Ostrict__implies__order,axiom,(
    ! [A2: nat,B: nat] :
      ( ( ord_less_nat @ A2 @ B )
     => ( ord_less_eq_nat @ A2 @ B ) ) )).

% order.strict_implies_order
thf(fact_250_dual__order_Ostrict__trans2,axiom,(
    ! [B: set_nat,A2: set_nat,C: set_nat] :
      ( ( ord_less_set_nat @ B @ A2 )
     => ( ( ord_less_eq_set_nat @ C @ B )
       => ( ord_less_set_nat @ C @ A2 ) ) ) )).

% dual_order.strict_trans2
thf(fact_251_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A2: nat,C: nat] :
      ( ( ord_less_nat @ B @ A2 )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A2 ) ) ) )).

% dual_order.strict_trans2
thf(fact_252_dual__order_Ostrict__trans1,axiom,(
    ! [B: set_nat,A2: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A2 )
     => ( ( ord_less_set_nat @ C @ B )
       => ( ord_less_set_nat @ C @ A2 ) ) ) )).

% dual_order.strict_trans1
thf(fact_253_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A2: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A2 )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A2 ) ) ) )).

% dual_order.strict_trans1
thf(fact_254_order_Ostrict__iff__order,axiom,
    ( ord_less_set_nat
    = ( ^ [A4: set_nat,B4: set_nat] :
          ( ( ord_less_eq_set_nat @ A4 @ B4 )
          & ( A4 != B4 ) ) ) )).

% order.strict_iff_order
thf(fact_255_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ A4 @ B4 )
          & ( A4 != B4 ) ) ) )).

% order.strict_iff_order
thf(fact_256_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_set_nat
    = ( ^ [A4: set_nat,B4: set_nat] :
          ( ( ord_less_set_nat @ A4 @ B4 )
          | ( A4 = B4 ) ) ) )).

% order.order_iff_strict
thf(fact_257_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_nat @ A4 @ B4 )
          | ( A4 = B4 ) ) ) )).

% order.order_iff_strict
thf(fact_258_order_Ostrict__trans2,axiom,(
    ! [A2: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_set_nat @ A2 @ B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_set_nat @ A2 @ C ) ) ) )).

% order.strict_trans2
thf(fact_259_order_Ostrict__trans2,axiom,(
    ! [A2: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A2 @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A2 @ C ) ) ) )).

% order.strict_trans2

% Conjectures (2)
thf(conj_0,hypothesis,(
    $true )).

thf(conj_1,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
